resource_name :kernelcare
provides :kernelcare

property :auto_update, [true, false], default: true
property :registration_key, String
property :patch_server, String
property :registration_url, String
property :prefix, String
property :sticky_patch, String
property :update, [true, false], default: true


property :install_script_url, String, default: 'https://kernelcare.com/installer'
property :config_location, String, default: '/etc/sysconfig/kcare/kcare.conf'

action :install do

    remote_file 'download_install_script' do
        source new_resource.install_script_url
        path "/tmp/kernelcare_install.sh"
        action :create
    end

    execute "install_kernelcare" do
        command "bash /tmp/kernelcare_install.sh"
        creates "/etc/sysconfig/kcare/kcare.conf"
    end

    if property_is_set?(:registration_key)
        execute "kcarectl --register #{new_resource.registration_key}" do
            creates "/etc/sysconfig/kcare/systemid"
        end
    end

    if property_is_set?(:patch_server)
        execute "sed -i 's/^AUTO_UPDATE=/AUTO_UPDATE=#{new_resource.auto_update}/'g #{new_resource.config_location}"
    end

    if property_is_set?(:patch_server)
        execute "sed -i 's/^PATCH_SERVER=/PATCH_SERVER=#{new_resource.patch_server}/'g #{new_resource.config_location}"
    end

    execute "kcarectl --update" do
        only_if {new_resource.update}
    end
end